searchNodes=[{"doc":"Construct classes with variant definitions. A variant consists of a name and a class. These variants are defined by providing a declarative set of nested keyword lists. defmodule MyCVA do import CVA def button ( props ) do config = [ variants : [ intent : [ primary : &quot;bg-cyan-600&quot; , secondary : &quot;bg-zinc-700&quot; , destructive : &quot;bg-red-500&quot; ] , size : [ xs : &quot;rounded px-2.5 py-1.5 text-xs&quot; , sm : &quot;rounded-md px-3 py-2 text-sm&quot; , md : &quot;rounded-md px-4 py-2 text-sm&quot; , lg : &quot;rounded-md px-4 py-2 text-base&quot; , xl : &quot;rounded-md px-6 py-3 text-base&quot; ] ] ] cva ( config , props ) end end Invoking button/1 with the desired variants will return a class name including the classes specified in the config. button ( intent : :primary , size : :md ) # -&gt; &quot;bg-cyan-600 rounded-md px-4 py-2 text-sm&quot; See cva/3 for more info. ## Usage with Phoenix function components. CVA integrates nicely with Phoenix function components by providing variant/3 and compound_variant/2 macros. Please refer to the CVA.Component module.","ref":"CVA.html","title":"CVA","type":"module"},{"doc":"See cva/3 .","ref":"CVA.html#cva/1","title":"CVA.cva/1","type":"function"},{"doc":"See cva/3 .","ref":"CVA.html#cva/2","title":"CVA.cva/2","type":"function"},{"doc":"Construct a class string from a variant configuration. Accepts a base class string, a variant configuration, and a list of props. config = [ variants : [ intent : [ primary : &quot;bg-cyan-600&quot; , secondary : &quot;bg-zinc-700&quot; , destructive : &quot;bg-red-500&quot; ] , size : [ xs : &quot;rounded px-2.5 py-1.5 text-xs&quot; , sm : &quot;rounded-md px-3 py-2 text-sm&quot; , md : &quot;rounded-md px-4 py-2 text-sm&quot; , lg : &quot;rounded-md px-4 py-2 text-base&quot; , xl : &quot;rounded-md px-6 py-3 text-base&quot; ] ] , default_variants : [ intent : :secondary , size : :md ] , compound_variants : [ [ intent : :primary , size : :xl , class : &quot;uppercase&quot; ] ] ] cva ( &quot;base&quot; , config , intent : :primary , size : :md ) # -&gt; &quot;base bg-cyan-600 rounded-md px-4 py-2 text-sm&quot; cva ( &quot;base&quot; , config , intent : :primary , size : :xl ) # -&gt; &quot;base bg-cyan-600 rounded-md px-6 py-3 text-base uppercase&quot; cva ( &quot;base&quot; , config , intent : :primary , size : :xl ) # -&gt; &quot;base bg-cyan-600 rounded-md px-6 py-3 text-base uppercase&quot; cva ( &quot;base&quot; , config ) # -&gt; &quot;base bg-zinc-700 rounded-md px-4 py-2 text-sm&quot; cva ( &quot;base&quot; , config , intent : :primary ) # -&gt; &quot;base bg-cyan-600 rounded-md px-4 py-2 text-sm&quot; Config The configuration is a keyword list with the following keys: :variants - A keyword list of variants. Each variant is a keyword list of variant names and classes. :compound_variants - A list of compound variants. Each compound variant is a keyword list of required variants and a :class key to specify the class which should be applied if all variants are present. :default_variants - A keyword list of default variants. For example [intent: :primary] . Props Props define the variants to be applied. Each key in the props list must be a variant name. Values can either be an atom or a string. Special props :class - A class string or list of classes. This class is applied last.","ref":"CVA.html#cva/3","title":"CVA.cva/3","type":"function"},{"doc":"Merges a list of classes into a single class string removing any nil or empty strings. Class lists can be infinitely nested.","ref":"CVA.html#cx/1","title":"CVA.cx/1","type":"function"},{"doc":"Integrates CVA with Phoenix function components. The variant/3 and compound_variant/2 macros allow easy definition of variants and compound variants for a component. This also includes compile time checks for the specified variants. When using this module, please make sure that you add include :cva to your imports in .formatter.exs . [ import_deps : [ :cva ] , ] Usage defmodule MyWeb.Components do use CVA.Component variant :intent , [ primary : &quot;bg-cyan-600&quot; , secondary : &quot;bg-zinc-700&quot; , destructive : &quot;bg-red-500&quot; ] , default : :secondary variant :size , [ xs : &quot;rounded px-2.5 py-1.5 text-xs&quot; , sm : &quot;rounded-md px-3 py-2 text-sm&quot; , md : &quot;rounded-md px-4 py-2 text-sm&quot; , lg : &quot;rounded-md px-4 py-2 text-base&quot; , xl : &quot;rounded-md px-6 py-3 text-base&quot; ] , default : :md compound_variant &quot;uppercase&quot; , intent : :primary , size : :xl attr :rest , :global slot :inner_block def button ( assigns ) do ~H&quot;&quot;&quot; &lt;button class={@cva_class} {@rest}&gt;&lt;%= render_slot(@inner_block) %&gt;&lt;/button&gt; &quot;&quot;&quot; end end defmodule MyWeb.SomeLive do import MyWeb.Components def render ( assigns ) do ~H&quot;&quot;&quot; &lt;.button intent=&quot;primary&quot;&gt;Click me&lt;/.button&gt; &quot;&quot;&quot; end end","ref":"CVA.Component.html","title":"CVA.Component","type":"module"},{"doc":"Declares a compound variant for HEEx function components. A compound variant defines a set of required variants. If all variants are present, the given class will be assigned. A component can have multiple compound variants. Arguments class - the class to add if all variants are present. variants - a keyword list of required variants. Example defmodule MyWeb.Components do use CVA.Component variant :intent , [ primary : &quot;bg-cyan-600&quot; , secondary : &quot;bg-zinc-700&quot; , ] , default : :secondary variant :size , [ md : &quot;rounded-md px-4 py-2 text-sm&quot; , xl : &quot;rounded-md px-6 py-3 text-base&quot; ] , default : :md compound_variant &quot;uppercase&quot; , intent : :primary , size : :xl def button ( assigns ) do ~H&quot;&quot;&quot; &lt;button class={@cva_class} {@rest}&gt;&lt;%= render_slot(@inner_block) %&gt;&lt;/button&gt; &quot;&quot;&quot; end end","ref":"CVA.Component.html#compound_variant/2","title":"CVA.Component.compound_variant/2","type":"macro"},{"doc":"Declares a variant for HEEx function components. When declaring variants, an assign cva_class is added to the component. This assign contains the class according to all variant definitions of the component. This class is intended to be passed into the class attribute of the component. A component can have multiple variants. Arguments name - an atom defining the name of the attribute. Note that attributes cannot define the same name as any other attributes or slots or attributes declared for the same component. variants - a keyword list of variants. opts - a keyword list of options. Defaults to [] . Options * ` default ` - the default variant . All other options will be passed to ` Phoenix.Component . attr / 3 ` . Example defmodule MyWeb.Components do use CVA.Component variant :intent , [ primary : &quot;bg-cyan-600&quot; , secondary : &quot;bg-zinc-700&quot; , destructive : &quot;bg-red-500&quot; ] , default : :secondary variant :size , [ xs : &quot;rounded px-2.5 py-1.5 text-xs&quot; , sm : &quot;rounded-md px-3 py-2 text-sm&quot; , md : &quot;rounded-md px-4 py-2 text-sm&quot; , lg : &quot;rounded-md px-4 py-2 text-base&quot; , xl : &quot;rounded-md px-6 py-3 text-base&quot; ] , default : :md def button ( assigns ) do ~H&quot;&quot;&quot; &lt;button class={@cva_class} {@rest}&gt;&lt;%= render_slot(@inner_block) %&gt;&lt;/button&gt; &quot;&quot;&quot; end end","ref":"CVA.Component.html#variant/3","title":"CVA.Component.variant/3","type":"macro"}]